package gift

import (
	"context"
	"live-service/app/user_center/rpc/internal/svc"
	"live-service/app/user_center/rpc/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type UserBuyNobilityLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewUserBuyNobilityLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UserBuyNobilityLogic {
	return &UserBuyNobilityLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// UserBuyNobility 用户购买贵族
// 1. 记录送礼
// 2. 新增积分
// 3. 修改贵族
func (l *UserBuyNobilityLogic) UserBuyNobility(in *pb.UserBuyNobilityReq) (*pb.UserBuyNobilityResp, error) {
	// TODO 未完成
	//// 记录送礼信息
	//{
	//	dbUserGift := &model.UserGift{
	//		Id:       uuid.NextId(),
	//		UserId:   in.UserId,
	//		Platform: in.Platform,
	//		RoomId:   in.RoomId,
	//		GiftId:   strconv.FormatInt(in.GiftId, 10),
	//		GiftName: in.GiftName,
	//		Num:      in.Num,
	//	}
	//	if in.IsPaid {
	//		dbUserGift.Price = in.Price
	//	} else {
	//		dbUserGift.FreePrice = in.Price
	//	}
	//	if err := l.svcCtx.UserGiftModel.Insert(l.ctx, nil, dbUserGift); err != nil {
	//		l.Logger.Errorf("记录用户[%d]送礼信息 [%d:%s:%d] 失败，操作继续...", in.UserId, in.GiftId, in.GiftName, in.Num)
	//	}
	//}
	return &pb.UserBuyNobilityResp{}, nil
}
