package rank

import (
	"context"

	"live-service/app/user_center/rpc/internal/svc"
	"live-service/app/user_center/rpc/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type UserRankPvpLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewUserRankPvpLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UserRankPvpLogic {
	return &UserRankPvpLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *UserRankPvpLogic) UserRankPvp(in *pb.UserRankReq) (*pb.UserRankResp, error) {
	// 1. 查询用户自己当前分数
	// 2. 获取排名
	// 3. 所有排名信息（需要首先判断）
	if in.AllRankType {
		//in.UserId

	} else {
		// 只查询一种类型
	}
	return &pb.UserRankResp{}, nil
}
