package nerr

// 成功返回
const OK uint32 = 200

/** 前3位标识业务，后3位标识具体功能 **/

// 全局错误

const (
	ServerCommonError         uint32 = 100001
	RequestParamError         uint32 = 100002
	TokenExpireError          uint32 = 100003
	TokenGenerateError        uint32 = 100004
	DBError                   uint32 = 100005
	DBUpdateAffectedZeroError uint32 = 100006
	CopyError                 uint32 = 100007
)

// 用户积分相关 UserIntegral

const (
	UserIntegralNotEnoughError uint32 = 200100 // 用户积分不足
)

// 礼包相关 GiftPack

const (
	GiftPackHasDrawError          = 201100 // 该礼包已经领取过
	GiftPackDrawCountLimitedError = 201101 // 该礼包已领取完
)
